#cs ----------------------------------------------------------------------------
	
	AutoIt Version : 3.3.10.2
	Auteur:         Uranium
	
	Fonction du Script :
	Permet l'entranement d'un rseau neuronal sur la fonction logique NOT AND
	
#ce ----------------------------------------------------------------------------

#include <GuiConstantsEx.au3>
#include <Misc.au3>

Opt("MustDeclareVars", 1)

Global $x1, $x2, $x3, $w1, $w2, $w3, $t, $s, $nMsg, $c, $Ss, $i ;Initialisation des variables importantes ( Entres (x1,x2x3) , poids(w1,w2,w3) , compteur($t) , valeur de sortie ($s), valeur attendue ($i)
$s = 0 ;Initialisation de la valeur de sortie  0


Global $hGUI = GUICreate("Show PNG", 190, 115, 192, 125) ; Cration de l'interface
Global $Ix1 = GUICtrlCreateInput("x1", 8, 8, 33, 21)
Global $Ix2 = GUICtrlCreateInput("x2", 8, 48, 33, 21)
Global $Ss = GUICtrlCreateInput("Sortie", 152, 64, 33, 21)
Global $Iw1 = GUICtrlCreateInput("w1", 64, 8, 33, 21)
Global $Iw2 = GUICtrlCreateInput("w2", 64, 48, 33, 21)
Global $Ix3 = GUICtrlCreateInput("x3", 8, 80, 33, 21)
Global $Iw3 = GUICtrlCreateInput("w3", 64, 80, 33, 21)
GUISetState()

GUICtrlSetData($Ix1, 1) ; Cration d'une entre supplmentaire toujours  1 pour atteindre plus facilement la valeur seuil d'activation

Do ; Entranement du rseau 10 fois

	$i = 0 ; Attribution de la valeur de sortie attendu
	GUICtrlSetData($Ix3, 1) ; Attribution des entres
	GUICtrlSetData($Ix2, 1)
	_Calcul()

	$i = 1; Attribution de la valeur de sortie attendu
	GUICtrlSetData($Ix3, 0); Attribution des entres
	GUICtrlSetData($Ix2, 1)
	_Calcul()

	$i = 1; Attribution de la valeur de sortie attendu
	GUICtrlSetData($Ix3, 1); Attribution des entres
	GUICtrlSetData($Ix2, 0)
	_Calcul()

	$i = 1; Attribution de la valeur de sortie attendu
	GUICtrlSetData($Ix3, 0); Attribution des entres
	GUICtrlSetData($Ix2, 0)
	_Calcul()

	$t += 1 ; Compteur d'entranement effectu
Until $t > 10

Sleep(2000)
_Save()


Exit

; #FUNCTION# ====================================================================================================================
; Name ..........: _Calcul
; Description ...: Permet la correction des poids en fonction de la sortie attendue ($i) par apport  la sortie relle ($s) et des entres
; Syntaxe ........: _Calcul()
; Paramtres ....: Aucun
; Return values .: Aucune
; Author ........: Uranium
; ===============================================================================================================================

Func _Calcul()
	Do
		$c = GUICtrlRead($Ix1) * GUICtrlRead($Iw1) + GUICtrlRead($Ix2) * GUICtrlRead($Iw2) + GUICtrlRead($Ix3) * GUICtrlRead($Iw3) ;Calcul de la "somme pondre"
		If $c > 0.5 Then ; Attribution de la sortie par apport  la valeur de la somme pondre et du seuil d'activation de 0.5
			$s = 1
		Else
			$s = 0
		EndIf

		GUICtrlSetData($Ss, $s)

		$w1 = GUICtrlRead($Iw1) + 0.1 * GUICtrlRead($Ix1) * ($i - $s) ; Correction des poids
		GUICtrlSetData($Iw1, $w1)
		$w2 = GUICtrlRead($Iw2) + 0.1 * GUICtrlRead($Ix2) * ($i - $s)
		GUICtrlSetData($Iw2, $w2)
		$w3 = GUICtrlRead($Iw3) + 0.1 * GUICtrlRead($Ix3) * ($i - $s)
		GUICtrlSetData($Iw3, $w3)

	Until $s = $i ; Correction des poids jusqu' ce que la valeur de sortie corresponde  la valeur attendue

EndFunc   ;==>_Calcul

; #FUNCTION# ====================================================================================================================
; Name ..........: _Save
; Description ...: Enregistrement des poids pour utilisation extrieure
; Syntax ........: _Save()
; Parameters ....: Aucun
; Return values .: Aucune
; Author ........: Uranium
; ===============================================================================================================================
Func _Save()
	IniWrite("score.ini", "poids", "W3", $w3)
	IniWrite("score.ini", "poids", "W1", $w1)
	IniWrite("score.ini", "poids", "W2", $w2)
EndFunc   ;==>_Save
